// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#ifndef _DB_DEBUG_H
#define _DB_DEBUG_H
#include <cstdlib>
typedef enum debug_val_e { check_bounds=1 } debug_flag_t;


const int debug_flags=check_bounds;

inline void check( const int val, const debug_flag_t f ) {
  if (debug_flags|f){
    // we rely on the optimizer to remove this if disabled.
    if (!val){
      abort();
    }
  }
}
#endif


