// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#include "kSet.hpp"

/* From Nijenhuis and Wilf, lexicographic order */ 
bool kSet::next(){
    
    int h,j,m1;


    if (state[0]==n-k+1) 
      return false;


    for (h=1; (h <= k)  &&       (state[k-h] == n+1-h) ; h++);

    m1=state[k-h];
    
    for (j=1; j<=h; j++){
	state[k+j-h-1]=m1+j;
    }

    return true;
}
