// Copyright (C) 2008 David Bremner
//
// Author: David Bremner (bremner@unb.ca)
// Version: $Id$
//
// This file is part of lpmargin.
//
// lpmargin is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 2 of the License, or
// (at your option) any later version.
//
// lpmargin is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with lpmargin.  If not, see <http://www.gnu.org/licenses/>.
#include <iostream>
#include "Partition.h"

using std::cout;
using std::endl;
int main(int argc, char **argv){

  Partition sigma(7);

  do {
    primary_iterator i;
    complement_iterator j;
    for (i=sigma.begin(); i!=sigma.end(); i++){
      cout<< *i << " ";
    }
    cout <<"|";
    for ( j=sigma.cbegin(); j!=sigma.cend(); j++){
      cout << *j << " ";
    }

    for (i=sigma.begin(); i!=sigma.end(); i++){
      for ( j=sigma.cbegin(); j!=sigma.cend(); j++){
	cout << *i <<":" << *j  << endl;
      }
    }

    
    
    cout << endl;
    
  } while (sigma.next());
  
}
